(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/card', ['exports', '@angular/core', '@angular/common', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].card = {}), global.ng.core, global.ng.common, global['ng-element-ui'].core.outlet));
}(this, (function (exports, core, common, outlet) { 'use strict';

    var NelCardComponent = /** @class */ (function () {
        function NelCardComponent(elementRef) {
            this.elementRef = elementRef;
            this.nelBodyStyle = { padding: '20px' };
            this.nelShadow = 'always';
            this.elementRef.nativeElement.classList.add('el-card');
        }
        return NelCardComponent;
    }());
    NelCardComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-card',
                    template: "<div class=\"el-card__header\" *ngIf=\"nelHeader\">\r\n  <div class=\"card-header\">\r\n    <ng-container *stringTemplate=\"nelHeader\">{{nelHeader}}</ng-container>\r\n  </div>\r\n</div>\r\n<div class=\"el-card__body\" [ngStyle]=\"nelBodyStyle ? nelBodyStyle : null\">\r\n  <ng-content></ng-content>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        '[class.is-always-shadow]': "nelShadow == 'always'",
                        '[class.is-hover-shadow]': "nelShadow == 'hover'",
                        '[class.is-never-shadow]': "nelShadow == 'never'",
                        '[class.box-card]': "true",
                    }
                },] }
    ];
    NelCardComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    NelCardComponent.propDecorators = {
        nelHeader: [{ type: core.Input }],
        nelBodyStyle: [{ type: core.Input }],
        nelShadow: [{ type: core.Input }]
    };

    var NelCardModule = /** @class */ (function () {
        function NelCardModule() {
        }
        return NelCardModule;
    }());
    NelCardModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelCardComponent
                    ],
                    exports: [
                        NelCardComponent
                    ],
                    imports: [
                        common.CommonModule,
                        outlet.NelOutletModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelCardComponent = NelCardComponent;
    exports.NelCardModule = NelCardModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-card.umd.js.map
