(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/core/outlet', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].core = global['ng-element-ui'].core || {}, global['ng-element-ui'].core.outlet = {}), global.ng.core, global.ng.common));
}(this, (function (exports, core, common) { 'use strict';

    var StringTemplateContext = /** @class */ (function () {
        function StringTemplateContext() {
        }
        return StringTemplateContext;
    }());
    var NelStringTemplateDirective = /** @class */ (function () {
        function NelStringTemplateDirective(vcRef, templateRef) {
            this.vcRef = vcRef;
            this.templateRef = templateRef;
            this.context = new StringTemplateContext();
            this.stringTemplate = null;
            this.stringTemplateContext = null;
        }
        NelStringTemplateDirective.prototype.updateView = function () {
            this.clear();
            if (!this.stringTemplate) {
                return;
            }
            var isTemplateRef = this.stringTemplate instanceof core.TemplateRef;
            var templateRef = (isTemplateRef ? this.stringTemplate : this.templateRef);
            this.vcRef.createEmbeddedView(templateRef, isTemplateRef ? this.stringTemplateContext : this.context);
        };
        NelStringTemplateDirective.prototype.clear = function () {
            this.vcRef.clear();
        };
        NelStringTemplateDirective.prototype.ngOnChanges = function (changes) {
            this.updateView();
        };
        NelStringTemplateDirective.prototype.ngOnDestroy = function () {
            this.clear();
        };
        return NelStringTemplateDirective;
    }());
    NelStringTemplateDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[stringTemplate]',
                },] }
    ];
    NelStringTemplateDirective.ctorParameters = function () { return [
        { type: core.ViewContainerRef },
        { type: core.TemplateRef }
    ]; };
    NelStringTemplateDirective.propDecorators = {
        stringTemplate: [{ type: core.Input }],
        stringTemplateContext: [{ type: core.Input }]
    };

    var NelOutletModule = /** @class */ (function () {
        function NelOutletModule() {
        }
        return NelOutletModule;
    }());
    NelOutletModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelStringTemplateDirective
                    ],
                    exports: [
                        NelStringTemplateDirective
                    ],
                    imports: [
                        common.CommonModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelOutletModule = NelOutletModule;
    exports.NelStringTemplateDirective = NelStringTemplateDirective;
    exports.StringTemplateContext = StringTemplateContext;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-core-outlet.umd.js.map
