(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/core/services', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].core = global['ng-element-ui'].core || {}, global['ng-element-ui'].core.services = {}), global.ng.core));
}(this, (function (exports, i0) { 'use strict';

    var NelUpdateHostClassService = /** @class */ (function () {
        function NelUpdateHostClassService() {
            this.classMap = {};
        }
        NelUpdateHostClassService.prototype.updateHostClass = function (el, classMap) {
            this.removeClass(el, this.classMap, this.renderer);
            this.classMap = Object.assign({}, classMap);
            this.addClass(el, this.classMap, this.renderer);
        };
        NelUpdateHostClassService.prototype.removeClass = function (el, classMap, renderer) {
            for (var i in classMap) {
                if (classMap.hasOwnProperty(i)) {
                    renderer.removeClass(el, i);
                }
            }
        };
        NelUpdateHostClassService.prototype.addClass = function (el, classMap, rendreer) {
            for (var i in classMap) {
                if (classMap.hasOwnProperty(i)) {
                    if (classMap[i]) {
                        this.renderer.addClass(el, i);
                    }
                }
            }
        };
        return NelUpdateHostClassService;
    }());
    NelUpdateHostClassService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NelUpdateHostClassService_Factory() { return new NelUpdateHostClassService(); }, token: NelUpdateHostClassService, providedIn: "root" });
    NelUpdateHostClassService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelUpdateHostClassService = NelUpdateHostClassService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-core-services.umd.js.map
