(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng-element-ui/core/outlet'), require('ng-element-ui/icon')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/progress', ['exports', '@angular/core', '@angular/common', 'ng-element-ui/core/outlet', 'ng-element-ui/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].progress = {}), global.ng.core, global.ng.common, global['ng-element-ui'].core.outlet, global['ng-element-ui'].icon));
}(this, (function (exports, core, common, outlet, icon) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var defaultFormatter = function (p) { return p + "%"; };
    var ɵ0 = defaultFormatter;
    var NelProgressComponent = /** @class */ (function () {
        function NelProgressComponent() {
            this.nelPercentage = 0;
            this.nelStrokeWidth = 6;
            this.nelTextInside = false;
            this.nelType = 'line';
            this.nelWidth = 126;
            this.nelStrokeLinecap = 'round';
            this.nelIndeterminate = false;
            this.nelDuration = 3;
        }
        Object.defineProperty(NelProgressComponent.prototype, "formatter", {
            get: function () {
                return this.nelFormat || defaultFormatter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "formatterText", {
            get: function () {
                var isTemplateRef = this.nelFormat instanceof core.TemplateRef;
                if (isTemplateRef) {
                    return defaultFormatter;
                }
                else {
                    return this.nelFormat || defaultFormatter;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "relativeStrokeWidth", {
            get: function () {
                return (this.nelStrokeWidth / this.nelWidth * 100).toFixed(1);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "radius", {
            get: function () {
                if (this.nelType === 'circle' || this.nelType === 'dashboard') {
                    return parseInt("" + (50 - parseFloat(this.relativeStrokeWidth) / 2), 10);
                }
                else {
                    return 0;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "trackPath", {
            get: function () {
                var r = this.radius;
                var isDashboard = this.nelType === 'dashboard';
                return "\n        M 50 50\n        m 0 " + (isDashboard ? '' : '-') + r + "\n        a " + r + " " + r + " 0 1 1 0 " + (isDashboard ? '-' : '') + r * 2 + "\n        a " + r + " " + r + " 0 1 1 0 " + (isDashboard ? '' : '-') + r * 2 + "\n        ";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "perimeter", {
            get: function () {
                return 2 * Math.PI * this.radius;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "rate", {
            get: function () {
                return this.nelType === 'dashboard' ? 0.75 : 1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "strokeDashoffset", {
            get: function () {
                var offset = -1 * this.perimeter * (1 - this.rate) / 2;
                return offset + "px";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "trailPathStyle", {
            get: function () {
                return {
                    strokeDasharray: (this.perimeter * this.rate) + "px, " + this.perimeter + "px",
                    strokeDashoffset: this.strokeDashoffset,
                };
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "circlePathStyle", {
            get: function () {
                return {
                    strokeDasharray: this.perimeter * this.rate * (this.nelPercentage / 100) + "px, " + this.perimeter + "px",
                    strokeDashoffset: this.strokeDashoffset,
                    transition: 'stroke-dasharray 0.6s ease 0s, stroke 0.6s ease',
                };
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelProgressComponent.prototype, "stroke", {
            get: function () {
                var ret;
                if (this.nelColor) {
                    ret = this.getCurrentColor();
                }
                else {
                    switch (this.nelStatus) {
                        case 'success':
                            ret = '#13ce66';
                            break;
                        case 'exception':
                            ret = '#ff4949';
                            break;
                        case 'warning':
                            ret = '#e6a23c';
                            break;
                        default:
                            ret = '#20a0ff';
                    }
                }
                return ret;
            },
            enumerable: false,
            configurable: true
        });
        NelProgressComponent.prototype.ngOnInit = function () {
            if (this.nelType === 'circle') {
            }
        };
        NelProgressComponent.prototype.getCurrentColor = function () {
            var e_1, _b;
            var _a;
            if (this.nelColor) {
                if (this.nelColor === 'string') {
                    return this.nelColor;
                }
                else if (this.nelColor instanceof Function) {
                    return this.nelColor(this.nelPercentage);
                }
                else if (this.nelColor instanceof Array) {
                    var span_1 = 100 / this.nelColor.length;
                    var seriesColors = this.nelColor.map(function (seriesColor, index) {
                        if (typeof seriesColor === 'string') {
                            return {
                                color: seriesColor,
                                percentage: (index + 1) * span_1,
                            };
                        }
                        return seriesColor;
                    });
                    var colorArray = seriesColors.sort(function (a, b) { return a.percentage - b.percentage; });
                    try {
                        for (var colorArray_1 = __values(colorArray), colorArray_1_1 = colorArray_1.next(); !colorArray_1_1.done; colorArray_1_1 = colorArray_1.next()) {
                            var colorItem = colorArray_1_1.value;
                            if (colorItem.percentage > this.nelPercentage) {
                                return colorItem.color;
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (colorArray_1_1 && !colorArray_1_1.done && (_b = colorArray_1.return)) _b.call(colorArray_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return (_a = colorArray[colorArray.length - 1]) === null || _a === void 0 ? void 0 : _a.color;
                }
            }
            return null;
        };
        return NelProgressComponent;
    }());
    NelProgressComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-progress',
                    template: "<div class=\"el-progress\" [class.el-progress--line]=\"nelType == 'line'\" [class.el-progress--circle]=\"nelType == 'circle'\"\r\n  [class.el-progress--dashboard]=\"nelType == 'dashboard'\" [class.is-success]=\"nelStatus == 'success'\"\r\n  [class.is-exception]=\"nelStatus == 'exception'\" [class.is-warning]=\"nelStatus == 'warning'\" role=\"progressbar\">\r\n  <!-- bar -->\r\n  <ng-container *ngIf=\"nelType == 'line'; else circleDashboard\">\r\n    <div class=\"el-progress-bar\">\r\n      <div class=\"el-progress-bar__outer\" [style.height]=\"nelStrokeWidth + 'px'\">\r\n        <div class=\"el-progress-bar__inner\" [class.el-progress-bar__inner--indeterminate]=\"nelIndeterminate\"\r\n          [style.width]=\"nelPercentage + '%'\" [style.animation-duration]=\"nelDuration + 's'\"\r\n          [style.background-color]=\"getCurrentColor()\">\r\n          <div *ngIf=\"nelTextInside\" class=\"el-progress-bar__innerText\">\r\n            <ng-template *ngTemplateOutlet=\"formatTemplate\"></ng-template>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div *ngIf=\"!nelTextInside\" class=\"el-progress__text\" style=\"font-size: 14.4px;\">\r\n      <ng-template *ngTemplateOutlet=\"textTpl\"></ng-template>\r\n    </div>\r\n  </ng-container>\r\n  <!-- circle or dashboard -->\r\n  <ng-template #circleDashboard>\r\n    <div class=\"el-progress-circle\" [style.height]=\"nelWidth + 'px'\" [style.width]=\"nelWidth + 'px'\">\r\n      <svg viewBox=\"0 0 100 100\">\r\n        <path class=\"el-progress-circle__track\" [attr.d]=\"trackPath\" stroke=\"#e5e9f2\"\r\n          [attr.stroke-width]=\"relativeStrokeWidth\" fill=\"none\" [style]=\"trailPathStyle\"></path>\r\n        <path class=\"el-progress-circle__path\" [attr.d]=\"trackPath\" [attr.stroke]=\"stroke\" fill=\"none\"\r\n          [attr.stroke-linecap]=\"nelStrokeLinecap\" [attr.stroke-width]=\"nelPercentage ? relativeStrokeWidth : 0\"\r\n          [style]=\"circlePathStyle\">\r\n        </path>\r\n      </svg>\r\n    </div>\r\n    <div class=\"el-progress__text\" style=\"font-size: 16px;\">\r\n      <ng-template *ngTemplateOutlet=\"textTpl\"></ng-template>\r\n    </div>\r\n  </ng-template>\r\n  <ng-template #textTpl>\r\n    <ng-container\r\n      *ngIf=\"(nelStatus === 'success' || nelStatus === 'exception' || nelStatus === 'warning') && !nelFormat; else formatTemplate\">\r\n      <ng-container [ngSwitch]=\"nelStatus\">\r\n        <i *ngSwitchCase=\"'success'\" nel-icon [nelType]=\"nelType == 'line' ? 'circle-check' : 'check'\"></i>\r\n        <i *ngSwitchCase=\"'warning'\" nel-icon [nelType]=\"'warning'\"></i>\r\n        <i *ngSwitchCase=\"'exception'\" nel-icon [nelType]=\"nelType == 'line' ? 'circle-close' : 'close'\"></i>\r\n      </ng-container>\r\n    </ng-container>\r\n  </ng-template>\r\n  <ng-template #formatTemplate>\r\n    <span>\r\n      <ng-container *stringTemplate=\"formatter; context: { $implicit: nelPercentage }\">\r\n        {{ formatterText(nelPercentage) }}\r\n      </ng-container>\r\n    </span>\r\n  </ng-template>\r\n</div>\r\n"
                },] }
    ];
    NelProgressComponent.propDecorators = {
        nelPercentage: [{ type: core.Input }],
        nelFormat: [{ type: core.Input }],
        nelStatus: [{ type: core.Input }],
        nelStrokeWidth: [{ type: core.Input }],
        nelTextInside: [{ type: core.Input }],
        nelColor: [{ type: core.Input }],
        nelType: [{ type: core.Input }],
        nelWidth: [{ type: core.Input }],
        nelStrokeLinecap: [{ type: core.Input }],
        nelIndeterminate: [{ type: core.Input }],
        nelDuration: [{ type: core.Input }]
    };

    var NelProgressModule = /** @class */ (function () {
        function NelProgressModule() {
        }
        return NelProgressModule;
    }());
    NelProgressModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelProgressComponent
                    ],
                    exports: [
                        NelProgressComponent
                    ],
                    imports: [
                        common.CommonModule,
                        outlet.NelOutletModule,
                        icon.NelIconModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelProgressComponent = NelProgressComponent;
    exports.NelProgressModule = NelProgressModule;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-progress.umd.js.map
