(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/scrolling'), require('rxjs'), require('resize-observer-polyfill')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/scrollbar', ['exports', '@angular/core', '@angular/cdk/scrolling', 'rxjs', 'resize-observer-polyfill'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].scrollbar = {}), global.ng.core, global.ng.cdk.scrolling, global.rxjs, global.ResizeObserver));
}(this, (function (exports, core, scrolling, rxjs, ResizeObserver) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var ResizeObserver__default = /*#__PURE__*/_interopDefaultLegacy(ResizeObserver);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var NelScrollbarComponent = /** @class */ (function () {
        function NelScrollbarComponent() {
            this.nelNoresize = false;
            this.nelOnScroll = new core.EventEmitter();
            // 纵向滚动
            this.vertical = {
                // 是否可以纵向滚动
                canScroll: false,
                // 窗口高度
                wrapHeight: 0,
                // 滚动区域高度
                scrollHeight: 0,
                // 滚动条最大位置
                maxScrollTop: 0,
                // 滚动条位置
                scrollTop: 0,
                // 点击滚动条，起始位置
                clientY: 0,
                clientTop: 0
            };
            // 横向滚动
            this.horizontal = {
                // 是否可以横向滚动
                canScroll: false,
                // 窗口宽度
                wrapWidth: 0,
                // 滚动区域宽度
                scrollWidth: 0,
                // 滚动条最大位置
                maxScrollLeft: 0,
                // 滚动条位置
                scrollLeft: 0,
                // 点击滚动条，起始位置
                clientX: 0,
                clientLeft: 0
            };
            this.status = 'leave';
            this.inThumb = false;
        }
        Object.defineProperty(NelScrollbarComponent.prototype, "nelMaxHeight", {
            set: function (val) {
                if (val) {
                    if (typeof val === 'number') {
                        this.maxHeight = val + 'px';
                    }
                    else {
                        this.maxHeight = val;
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        NelScrollbarComponent.prototype.ngOnDestroy = function () {
            if (this.verticalMousemove) {
                this.verticalMousemove.unsubscribe();
            }
            if (this.verticalMouseup) {
                this.verticalMouseup.unsubscribe();
            }
            if (this.roWrap) {
                this.roWrap.unobserve(this.scrollbarWrap.nativeElement);
            }
            if (this.roView) {
                this.roView.unobserve(this.scrollbarView.nativeElement);
            }
        };
        NelScrollbarComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (!this.nelNoresize) {
                // 监听wrap
                this.roWrap = new ResizeObserver__default['default'](function (entries, observer) {
                    var e_1, _a;
                    try {
                        for (var entries_1 = __values(entries), entries_1_1 = entries_1.next(); !entries_1_1.done; entries_1_1 = entries_1.next()) {
                            var entry = entries_1_1.value;
                            var _b = entry.contentRect, width = _b.width, height = _b.height;
                            // 高度是否变化
                            if (height !== _this.vertical.wrapHeight) {
                                _this.initVertical();
                            }
                            // 宽度是否变化
                            if (width !== _this.horizontal.wrapWidth) {
                                _this.initHorizontal();
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (entries_1_1 && !entries_1_1.done && (_a = entries_1.return)) _a.call(entries_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                });
                this.roWrap.observe(this.scrollbarWrap.nativeElement);
                // 监听scroll
                this.roView = new ResizeObserver__default['default'](function (entries, observer) {
                    var e_2, _a;
                    try {
                        for (var entries_2 = __values(entries), entries_2_1 = entries_2.next(); !entries_2_1.done; entries_2_1 = entries_2.next()) {
                            var entry = entries_2_1.value;
                            var _b = entry.contentRect, width = _b.width, height = _b.height;
                            // 高度是否变化
                            if (height !== _this.vertical.scrollHeight) {
                                _this.initVertical();
                            }
                            // 宽度是否变化
                            if (width !== _this.horizontal.scrollWidth) {
                                _this.initHorizontal();
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (entries_2_1 && !entries_2_1.done && (_a = entries_2.return)) _a.call(entries_2);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                });
                this.roView.observe(this.scrollbarView.nativeElement);
            }
            this.initVertical();
            this.initHorizontal();
        };
        NelScrollbarComponent.prototype.initVertical = function () {
            // 初始化纵向滚动
            this.vertical.wrapHeight = this.scrollbarWrap.nativeElement.offsetHeight;
            this.vertical.scrollHeight = this.scrollbarWrap.nativeElement.scrollHeight;
            if (this.maxHeight) {
                var nelMaxHeight = this.maxHeight.match(/([0-9]+)px/);
                var maxHeight = 0;
                if (nelMaxHeight && nelMaxHeight.length > 0) {
                    maxHeight = Number(nelMaxHeight[1]);
                }
                if (maxHeight > 0 && maxHeight > this.vertical.wrapHeight) {
                    this.verticalThumb.nativeElement.style.height = '';
                    return;
                }
            }
            if (this.vertical.scrollHeight > this.vertical.wrapHeight) {
                // 纵向滚动
                this.vertical.canScroll = true;
                this.vertical.maxScrollTop = this.vertical.scrollHeight - this.vertical.wrapHeight;
                var heightPercentage = this.vertical.wrapHeight / this.vertical.scrollHeight;
                this.verticalThumb.nativeElement.style.height = heightPercentage * 100 + '%';
                this.verticalScrollHandle();
            }
        };
        NelScrollbarComponent.prototype.initHorizontal = function () {
            // 初始化横向滚动
            this.horizontal.wrapWidth = this.scrollbarWrap.nativeElement.offsetWidth;
            this.horizontal.scrollWidth = this.scrollbarWrap.nativeElement.scrollWidth;
            if (this.horizontal.scrollWidth > this.horizontal.wrapWidth) {
                // 横向滚动
                this.horizontal.canScroll = true;
                this.horizontal.maxScrollLeft = this.horizontal.scrollWidth - this.horizontal.wrapWidth;
                var widthPercentage = this.horizontal.wrapWidth / this.horizontal.scrollWidth;
                this.horizontalThumb.nativeElement.style.width = widthPercentage * 100 + '%';
                this.horizontalScrollHandle();
            }
        };
        NelScrollbarComponent.prototype.onWrapScroll = function ($event) {
            $event.stopPropagation();
            this.vertical.scrollTop = this.scrollbarWrap.nativeElement.scrollTop;
            this.verticalScrollHandle();
        };
        NelScrollbarComponent.prototype.verticalScrollHandle = function (scrollTop) {
            if (scrollTop === void 0) { scrollTop = false; }
            if (this.vertical.scrollTop < 0) {
                this.vertical.scrollTop = 0;
            }
            if (this.vertical.scrollTop > this.vertical.maxScrollTop) {
                this.vertical.scrollTop = this.vertical.maxScrollTop;
            }
            var transformPercentage = (this.vertical.scrollTop / this.vertical.wrapHeight);
            this.verticalThumb.nativeElement.style.transform = "translateY(" + transformPercentage * 100 + "%)";
            /**
             * 当拖动滚动条时，需要滚动到指定位置
             */
            if (scrollTop) {
                this.scrollbarWrap.nativeElement.scrollTop = this.vertical.scrollTop;
            }
            this.nelOnScroll.emit({
                scrollLeft: this.horizontal.scrollLeft,
                scrollTop: this.vertical.scrollTop
            });
        };
        NelScrollbarComponent.prototype.mouseEnter = function () {
            this.status = 'enter';
        };
        NelScrollbarComponent.prototype.mouseLeave = function () {
            if (!this.inThumb) {
                this.status = 'leave';
            }
        };
        NelScrollbarComponent.prototype.verticalThumbDown = function ($event) {
            var _this = this;
            $event.preventDefault();
            this.vertical.clientY = $event.clientY;
            this.vertical.clientTop = this.vertical.scrollTop;
            this.inThumb = true;
            // 打开移动事件
            this.verticalMousemove = rxjs.fromEvent(document, 'mousemove')
                .subscribe(function (event) {
                _this.verticalThumbMove(event);
            });
            this.verticalMouseup = rxjs.fromEvent(document, 'mouseup')
                .subscribe(function () {
                _this.inThumb = false;
                _this.verticalMousemove.unsubscribe();
                _this.verticalMouseup.unsubscribe();
            });
        };
        NelScrollbarComponent.prototype.verticalThumbMove = function ($event) {
            $event.preventDefault();
            var clientY = $event.clientY;
            var moveDistance = clientY - this.vertical.clientY;
            var thumbMoveDistance = this.vertical.wrapHeight - this.verticalThumb.nativeElement.offsetHeight;
            var scrollMoveDistance = this.vertical.scrollHeight - this.vertical.wrapHeight;
            var d = moveDistance / thumbMoveDistance * scrollMoveDistance;
            this.vertical.scrollTop = this.vertical.clientTop + d;
            this.verticalScrollHandle(true);
        };
        NelScrollbarComponent.prototype.horizontalThumbDown = function ($event) {
            var _this = this;
            $event.preventDefault();
            this.horizontal.clientX = $event.clientX;
            this.horizontal.clientLeft = this.horizontal.scrollLeft;
            this.inThumb = true;
            // 打开移动事件
            this.horizontalMousemove = rxjs.fromEvent(document, 'mousemove')
                .subscribe(function (event) {
                _this.horizontalThumbMove(event);
            });
            this.horizontalMouseup = rxjs.fromEvent(document, 'mouseup')
                .subscribe(function () {
                _this.inThumb = false;
                _this.horizontalMousemove.unsubscribe();
                _this.horizontalMouseup.unsubscribe();
            });
        };
        NelScrollbarComponent.prototype.horizontalThumbMove = function ($event) {
            $event.preventDefault();
            var clientX = $event.clientX;
            var moveDistance = clientX - this.horizontal.clientX;
            var thumbMoveDistance = this.horizontal.wrapWidth - this.horizontalThumb.nativeElement.offsetWidth;
            var scrollMoveDistance = this.horizontal.scrollWidth - this.horizontal.wrapWidth;
            var d = moveDistance / thumbMoveDistance * scrollMoveDistance;
            this.horizontal.scrollLeft = this.horizontal.clientLeft + d;
            this.horizontalScrollHandle(true);
        };
        NelScrollbarComponent.prototype.horizontalScrollHandle = function (scrollTop) {
            if (scrollTop === void 0) { scrollTop = false; }
            if (this.horizontal.scrollLeft < 0) {
                this.horizontal.scrollLeft = 0;
            }
            if (this.horizontal.scrollLeft > this.horizontal.maxScrollLeft) {
                this.horizontal.scrollLeft = this.horizontal.maxScrollLeft;
            }
            var transformPercentage = (this.horizontal.scrollLeft / this.horizontal.wrapWidth);
            this.horizontalThumb.nativeElement.style.transform = "translateX(" + transformPercentage * 100 + "%)";
            /**
             * 当拖动滚动条时，需要滚动到指定位置
             */
            if (scrollTop) {
                this.scrollbarWrap.nativeElement.scrollLeft = this.horizontal.scrollLeft;
            }
            this.nelOnScroll.emit({
                scrollLeft: this.horizontal.scrollLeft,
                scrollTop: this.vertical.scrollTop
            });
        };
        return NelScrollbarComponent;
    }());
    NelScrollbarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-scrollbar',
                    template: "<div class=\"el-scrollbar\" (mouseenter)=\"mouseEnter()\" (mouseleave)=\"mouseLeave()\">\r\n  <div #scrollbarWrap class=\"el-scrollbar__wrap el-scrollbar__wrap--hidden-default {{nelWrapClass}}\"\r\n    [style.height]=\"nelHeight\" [style.max-height]=\"maxHeight\" cdkScrollable (scroll)=\"onWrapScroll($event)\">\r\n    <div #scrollbarView class=\"el-scrollbar__view {{nelViewClass}}\">\r\n      <ng-content></ng-content>\r\n    </div>\r\n  </div>\r\n  <div class=\"el-scrollbar__bar is-horizontal\"\r\n    [style.display]=\"!horizontal.canScroll || status == 'leave' ? 'none' : ''\">\r\n    <div #horizontalThumb class=\"el-scrollbar__thumb\" (mousedown)=\"horizontalThumbDown($event)\"></div>\r\n  </div>\r\n  <div class=\"el-scrollbar__bar is-vertical\" [style.display]=\"!vertical.canScroll || status == 'leave' ? 'none' : ''\">\r\n    <div #verticalThumb class=\"el-scrollbar__thumb\" (mousedown)=\"verticalThumbDown($event)\"></div>\r\n  </div>\r\n</div>\r\n"
                },] }
    ];
    NelScrollbarComponent.propDecorators = {
        nelHeight: [{ type: core.Input }],
        nelNoresize: [{ type: core.Input }],
        nelMaxHeight: [{ type: core.Input }],
        nelWrapClass: [{ type: core.Input }],
        nelViewClass: [{ type: core.Input }],
        nelOnScroll: [{ type: core.Output }],
        scrollbarWrap: [{ type: core.ViewChild, args: ['scrollbarWrap', { static: false },] }],
        scrollbarView: [{ type: core.ViewChild, args: ['scrollbarView', { static: false },] }],
        verticalThumb: [{ type: core.ViewChild, args: ['verticalThumb', { static: false },] }],
        horizontalThumb: [{ type: core.ViewChild, args: ['horizontalThumb', { static: false },] }]
    };

    var NelScrollbarModule = /** @class */ (function () {
        function NelScrollbarModule() {
        }
        return NelScrollbarModule;
    }());
    NelScrollbarModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelScrollbarComponent
                    ],
                    exports: [
                        NelScrollbarComponent
                    ],
                    imports: [
                        scrolling.ScrollingModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelScrollbarComponent = NelScrollbarComponent;
    exports.NelScrollbarModule = NelScrollbarModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-scrollbar.umd.js.map
