(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng-element-ui/icon')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/timeline', ['exports', '@angular/core', '@angular/common', 'ng-element-ui/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].timeline = {}), global.ng.core, global.ng.common, global['ng-element-ui'].icon));
}(this, (function (exports, core, common, icon) { 'use strict';

    var NelTimelineComponent = /** @class */ (function () {
        function NelTimelineComponent() {
        }
        return NelTimelineComponent;
    }());
    NelTimelineComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-timeline',
                    template: "<ul class=\"el-timeline\">\r\n  <ng-content></ng-content>\r\n</ul>\r\n"
                },] }
    ];

    var NelTimelineItemComponent = /** @class */ (function () {
        function NelTimelineItemComponent() {
            this.nelSize = 'normal';
            this.nelHideTimestamp = false;
        }
        return NelTimelineItemComponent;
    }());
    NelTimelineItemComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-timeline-item',
                    template: "<div class=\"el-timeline-item__tail\"></div>\r\n<div class=\"el-timeline-item__node el-timeline-item__node--\"\r\n  [class.el-timeline-item__node--normal]=\"nelSize == 'normal'\"\r\n  [class.el-timeline-item__node--large]=\"nelSize != 'normal'\"\r\n  [class.el-timeline-item__node--primary]=\"nelType == 'primary'\"\r\n  [class.el-timeline-item__node--success]=\"nelType == 'success'\"\r\n  [class.el-timeline-item__node--warning]=\"nelType == 'warning'\"\r\n  [class.el-timeline-item__node--danger]=\"nelType == 'danger'\" [class.el-timeline-item__node--info]=\"nelType == 'info'\"\r\n  [style.backgroundColor]=\"nelColor\">\r\n  <i *ngIf=\"nelIcon\" nel-icon [nelType]=\"nelIcon\" class=\"el-timeline-item__icon\"></i>\r\n</div>\r\n<div class=\"el-timeline-item__wrapper\">\r\n  <div *ngIf=\"!nelHideTimestamp && nelPlacement == 'top'\" class=\"el-timeline-item__timestamp is-top\">{{nelTimestamp}}\r\n  </div>\r\n  <div class=\"el-timeline-item__content\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n  <div *ngIf=\"!nelHideTimestamp && nelPlacement == 'bottom'\" class=\"el-timeline-item__timestamp is-bottom\">\r\n    {{nelTimestamp}}</div>\r\n</div>\r\n",
                    host: {
                        class: 'el-timeline-item'
                    }
                },] }
    ];
    NelTimelineItemComponent.propDecorators = {
        nelTimestamp: [{ type: core.Input }],
        nelSize: [{ type: core.Input }],
        nelColor: [{ type: core.Input }],
        nelType: [{ type: core.Input }],
        nelIcon: [{ type: core.Input }],
        nelPlacement: [{ type: core.Input }],
        nelHideTimestamp: [{ type: core.Input }]
    };

    var NelTimelineModule = /** @class */ (function () {
        function NelTimelineModule() {
        }
        return NelTimelineModule;
    }());
    NelTimelineModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelTimelineComponent,
                        NelTimelineItemComponent
                    ],
                    exports: [
                        NelTimelineComponent,
                        NelTimelineItemComponent
                    ],
                    imports: [
                        common.CommonModule,
                        icon.NelIconModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelTimelineComponent = NelTimelineComponent;
    exports.NelTimelineItemComponent = NelTimelineItemComponent;
    exports.NelTimelineModule = NelTimelineModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-timeline.umd.js.map
