import { AfterViewInit, ElementRef, Renderer2 } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
export declare class NelButtonComponent implements AfterViewInit {
    private elementRef;
    private renderer;
    static ngAcceptInputType_nelPlain: BooleanInput;
    static ngAcceptInputType_nelRound: BooleanInput;
    static ngAcceptInputType_nelCircle: BooleanInput;
    static ngAcceptInputType_nelLoading: BooleanInput;
    nelType: string;
    nelPlain: boolean;
    nelRound: boolean;
    nelIcon: string;
    nelCircle: boolean;
    nelDisabled: boolean;
    set disabled(value: any);
    nelLoading: boolean;
    nelSize: string;
    constructor(elementRef: ElementRef, renderer: Renderer2);
    ngAfterViewInit(): void;
    insertSpan(nodes: NodeList, renderer: Renderer2): void;
}
