import { ChangeDetectorRef, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
declare type NelCalendarDateTemplate = TemplateRef<{
    $implicit: Date;
}>;
export declare class NelCalendarComponent implements ControlValueAccessor {
    private cdf;
    set nelRange(val: Array<Date>);
    nelDateCell?: NelCalendarDateTemplate;
    nzDateCellChild?: NelCalendarDateTemplate;
    get dateCell(): NelCalendarDateTemplate;
    current: {
        year: number;
        month: number;
    };
    data: Date;
    temporaryDate: Date;
    calendarList: any[];
    showButton: boolean;
    change: (value: any) => void;
    constructor(cdf: ChangeDetectorRef);
    initCalendar(date: Date, weeks: number, selectedDay?: Date | null): void;
    selectDay(dayItem: any): void;
    prevMonth(): void;
    getMonthDate(date: Date): number;
    currentMonth(): void;
    nextMonth(): void;
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
export {};
