import { AfterContentInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelCollapseItemComponent } from './collapse-item.component';
export declare class NelCollapseComponent implements ControlValueAccessor, AfterContentInit {
    static ngAcceptInputType_nelAccordion: BooleanInput;
    nelAccordion: boolean;
    itemList: Map<string | number, NelCollapseItemComponent>;
    data: string | Array<string> | null;
    change: (value: any) => void;
    changeItemActive(nelName: string | number, expanded: boolean): void;
    ngAfterContentInit(): void;
    writeValue(val: string | Array<string>): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
