import { QueryList, AfterContentInit, TemplateRef } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelDescriptionsItemComponent } from './descriptions-item.component';
export declare type ItemType = {
    type: string;
    label: string | TemplateRef<void> | undefined;
    content: TemplateRef<void> | null;
    colspan: number;
};
export declare class NelDescriptionsComponent implements AfterContentInit {
    static ngAcceptInputType_nelBorder: BooleanInput;
    nelTitle?: string;
    nelBorder: boolean;
    nelExtra?: string | TemplateRef<void>;
    nelSize?: 'medium' | 'small' | 'mini' | string;
    nelColumn: number;
    nelDirection: 'vertical' | 'horizontal';
    items: QueryList<NelDescriptionsItemComponent>;
    list: never[];
    itemList: Array<Array<ItemType>>;
    constructor();
    ngAfterContentInit(): void;
}
