import { EventEmitter, TemplateRef, ViewContainerRef } from '@angular/core';
import { Overlay, OverlayRef } from '@angular/cdk/overlay';
import { BooleanInput } from '@angular/cdk/coercion';
import { Observable } from 'rxjs';
export declare class NelDialogComponent {
    private overlay;
    private viewContainerRef;
    static ngAcceptInputType_nelCenter: BooleanInput;
    set nelVisible(value: boolean);
    nelTitle?: string | TemplateRef<void>;
    nelContent?: string | TemplateRef<void>;
    nelFooter?: string | TemplateRef<void>;
    nelVisibleChange: EventEmitter<boolean>;
    nelOnClose: EventEmitter<void>;
    nelBeforeClose?: () => boolean | Observable<boolean>;
    nelCenter: boolean;
    dialogTpl?: TemplateRef<any>;
    overlayRef?: OverlayRef;
    constructor(overlay: Overlay, viewContainerRef: ViewContainerRef);
    openWithTemplate(tpl: TemplateRef<any>): void;
    handleClose(): void;
    close(): void;
    clickDialog($event: Event): void;
}
