import { ElementRef, OnDestroy, Renderer2 } from '@angular/core';
import { CdkOverlayOrigin, ConnectionPositionPair } from '@angular/cdk/overlay';
import { TriggerType, SizeType } from './dropdown.directive';
import { NelDropdownService } from './dropdown.service';
export declare class NelDropdownMenuComponent implements OnDestroy {
    elementRef: ElementRef;
    private renderer;
    private dropdown;
    trigger: TriggerType;
    origin: CdkOverlayOrigin;
    isOpen: boolean;
    positionStrategy: ConnectionPositionPair[];
    state: string;
    hideOnClick: boolean;
    size?: SizeType;
    maxHeight?: string | number;
    timer: any;
    dropdownEle: ElementRef;
    protected readonly triggerDisposables: Array<() => void>;
    constructor(elementRef: ElementRef, renderer: Renderer2, dropdown: NelDropdownService);
    ngOnDestroy(): void;
    initListen(): void;
    private removeTriggerListeners;
    mouseenter(): void;
    mouseleave(): void;
    onClickOutside(event: MouseEvent): void;
    close(): void;
}
