import { OverlayRef } from '@angular/cdk/overlay';
import { Subject } from 'rxjs';
export interface OverlayCloseEvent<R> {
    type: 'close';
    data: R | null;
}
export declare class ImageRef<R = any> {
    overlay: OverlayRef;
    nelUrlList: string[];
    nelInitialIndex?: number | undefined;
    nelInfinite: boolean;
    nelOnClose?: Function | undefined;
    nelOnSwitch?: Function | undefined;
    afterClosed$: Subject<OverlayCloseEvent<R>>;
    constructor(overlay: OverlayRef, nelUrlList: string[], nelInitialIndex?: number | undefined, nelInfinite?: boolean, nelOnClose?: Function | undefined, nelOnSwitch?: Function | undefined);
    colse(data: R | null): void;
    private _close;
}
