import { OnInit, ElementRef, QueryList, AfterViewInit } from '@angular/core';
import { ImageRef } from './image-ref';
export declare class NelImageViewerComponent implements OnInit, AfterViewInit {
    private imageRef;
    nelUrlList: string[];
    nelInitialIndex: number;
    nelInfinite: boolean;
    deg: number;
    scale: number;
    isOriginal: boolean;
    imgList: QueryList<ElementRef>;
    constructor(imageRef: ImageRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    close(): void;
    prev(): void;
    next(): void;
    rotateImage(val: number): void;
    scaleImage(val: number): void;
    setupTransform(transition?: boolean): void;
    changeType(): void;
    dragStarted(): void;
    wheelScroll($event: WheelEvent): void;
}
