import { AfterViewInit, ElementRef, OnDestroy, EventEmitter } from '@angular/core';
import { Subscription, Subject } from 'rxjs';
export declare class NelInfiniteScrollDirective implements AfterViewInit, OnDestroy {
    private elementRef;
    subscribeScoll: Subscription;
    subscribeReachBottom: Subscription;
    reachBottom$: Subject<any>;
    disabled: boolean;
    initData: boolean;
    nelDistance: number;
    set nelDisabled(value: boolean);
    nelDelay: number;
    nelImmediate: boolean;
    nelOnReachBottom: EventEmitter<void>;
    observer?: MutationObserver;
    container: HTMLElement;
    constructor(elementRef: ElementRef);
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    initScroll(): void;
    initImmediate(): void;
    immediate(): void;
    handleScroll(): void;
}
