import { DomSanitizer, SafeStyle } from '@angular/platform-browser';
export declare type ColReactive = {
    span: number;
    offset: number;
};
export declare class NelColDirective {
    private sanitizer;
    nelSpan: number;
    nelOffset: number;
    nelXs: number | ColReactive;
    nelSm: number | ColReactive;
    nelMd: number | ColReactive;
    nelLg: number | ColReactive;
    nelXl: number | ColReactive;
    parentGutter: number;
    constructor(sanitizer: DomSanitizer);
    getClass(): string;
    gutterStyle(): SafeStyle;
}
