import { QueryList, AfterContentInit } from '@angular/core';
import { SafeStyle, DomSanitizer } from '@angular/platform-browser';
import { NelColDirective } from './col.directive';
export declare type RowType = 'flex' | undefined;
export declare type RowJustify = 'start' | 'end' | 'center' | 'space-around' | 'space-between';
export declare class NelRowDirective implements AfterContentInit {
    private sanitizer;
    nelGutter: number;
    nelType: RowType;
    nelJustify: RowJustify;
    colList: QueryList<NelColDirective>;
    constructor(sanitizer: DomSanitizer);
    ngAfterContentInit(): void;
    gutterStyle(): SafeStyle;
}
