import { Injector } from '@angular/core';
import { Overlay } from '@angular/cdk/overlay';
import { LoadingRef } from './loading-ref';
export interface OptionsType {
    text?: string;
    spinner?: string;
    background?: string;
}
export declare class NelLoadingService {
    private overlay;
    private injector;
    loadingRef: LoadingRef;
    constructor(overlay: Overlay, injector: Injector);
    show<R = any>(options?: OptionsType): LoadingRef<R>;
    createInjector(ref: LoadingRef, inj: Injector): Injector;
    hide(): void;
}
