import { Injector, TemplateRef } from '@angular/core';
import { Overlay } from '@angular/cdk/overlay';
import { MessageBoxRef } from './message-box-ref';
export interface OptionsType {
    cancelButtonText?: string;
    confirmButtonText?: string;
    cancel?: Function;
    confirm?: Function;
    type?: string;
    beforeConfirm?: Function;
    center?: boolean;
}
export declare class NelMessageBoxService {
    private overlay;
    private injector;
    constructor(overlay: Overlay, injector: Injector);
    blank<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): MessageBoxRef<R>;
    alert<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): MessageBoxRef<R>;
    confirm<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): MessageBoxRef<R>;
    show<R = any>(type: string, title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): MessageBoxRef<R>;
    createInjector(ref: MessageBoxRef, inj: Injector): Injector;
}
