import { OverlayRef } from '@angular/cdk/overlay';
import { TemplateRef } from '@angular/core';
import { Subject } from 'rxjs';
export declare class MessageRef<R = any> {
    type: string;
    id: number;
    leave: Subject<number>;
    overlay: OverlayRef;
    nelContent: string | TemplateRef<void>;
    nelOptions?: any;
    height: number;
    top: number;
    componentInstance: R | null;
    constructor(type: string, id: number, leave: Subject<number>, overlay: OverlayRef, nelContent: string | TemplateRef<void>, nelOptions?: any);
    close(): void;
}
