import { TemplateRef, OnInit, AfterViewInit, OnDestroy, ElementRef } from '@angular/core';
import { OverlayRef } from '@angular/cdk/overlay';
import { AnimationEvent } from '@angular/animations';
import { NelNotificationRef, PositionType } from './notification-ref';
export declare class NelNotificationComponent implements OnInit, AfterViewInit, OnDestroy {
    private notificationRef;
    type: string;
    id: number;
    position: PositionType;
    top: number;
    bottom: number;
    title: string | TemplateRef<void>;
    content: string | TemplateRef<void>;
    showClose: boolean;
    duration: number;
    onClose?: Function;
    timer: any;
    state: string;
    overlay: OverlayRef;
    notificationEle: ElementRef;
    constructor(notificationRef: NelNotificationRef);
    ngOnDestroy(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    initTimer(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    mouseenter(): void;
    mouseleave(): void;
    close(): void;
}
