import { QueryList } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelRadioComponent, SizeType } from './radio.component';
import { NelRadioButtonComponent } from './radio-button.component';
import { NelRadioService } from './radio.service';
export declare class NelRadioGroupComponent implements ControlValueAccessor {
    private radio;
    static ngAcceptInputType_nelDisabled: BooleanInput;
    nelDisabled: boolean;
    nelSize: SizeType | undefined;
    radioList: QueryList<NelRadioComponent>;
    radioButtonList: QueryList<NelRadioButtonComponent>;
    data: any;
    change: (value: any) => void;
    constructor(radio: NelRadioService);
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
