import { TemplateRef, OnDestroy } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { Subject, Subscription } from 'rxjs';
export declare class NelSkeletonComponent implements OnDestroy {
    static ngAcceptInputType_nelAnimated: BooleanInput;
    rowList: number[];
    set nelRows(val: number);
    nelAnimated: boolean;
    nelTemplate?: string | TemplateRef<void>;
    set nelLoading(val: boolean);
    nelThrottle: number;
    loading: boolean;
    subscribeChangeLoading: Subscription;
    changeLoading$: Subject<any>;
    timeoutHandle: any;
    ngOnDestroy(): void;
}
