import { AfterContentInit, QueryList } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelStepComponent } from './step.component';
export declare type StatusType = 'wait' | 'process' | 'finish' | 'error' | 'success';
export declare class NelStepsComponent implements AfterContentInit {
    static ngAcceptInputType_nelAlignCenter: BooleanInput;
    static ngAcceptInputType_nelSimple: BooleanInput;
    initStatus: boolean;
    active: number;
    nelSpace?: number | string;
    nelFinishStatus: StatusType;
    nelAlignCenter: boolean;
    nelDirection: 'vertical' | 'horizontal';
    nelSimple: boolean;
    set nelActive(val: number);
    stepList: QueryList<NelStepComponent>;
    ngAfterContentInit(): void;
    changeActive(): void;
}
