import { ChangeDetectorRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BooleanInput } from '@angular/cdk/coercion';
import { Observable } from 'rxjs';
export declare class NelSwitchComponent implements ControlValueAccessor {
    private cdf;
    static ngAcceptInputType_nelDisabled: BooleanInput;
    static ngAcceptInputType_nelLoading: BooleanInput;
    nelWidth: number;
    nelActiveColor?: string;
    nelInactiveColor?: string;
    nelActiveText?: string;
    nelInactiveText?: string;
    nelDisabled: boolean;
    nelLoading: boolean;
    nelBeforeChange?: () => boolean | Observable<boolean>;
    data: boolean;
    change: (value: any) => void;
    constructor(cdf: ChangeDetectorRef);
    changeSwitch(): void;
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
