import { AfterViewInit, ElementRef, OnDestroy, EventEmitter } from '@angular/core';
import { Subject, Subscription } from 'rxjs';
export declare class NelAffixComponent implements AfterViewInit, OnDestroy {
    private elementRef;
    nelOffset: number;
    nelTarget?: HTMLElement;
    nelPosition: 'top' | 'bottom';
    nelZIndex: number;
    nelOnChange: EventEmitter<boolean>;
    nelOnScroll: EventEmitter<{
        scrollTop: number;
        affix: boolean;
    }>;
    fixed: boolean;
    width: number;
    height: number;
    container: HTMLElement;
    subscribeScoll: Subscription;
    reachBottom$: Subject<any>;
    fixedEle: ElementRef;
    constructor(elementRef: ElementRef);
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    initScroll(): void;
    handleScroll(init?: boolean): void;
    changeFixed(fixed: boolean): void;
}
