import { EventEmitter, TemplateRef } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
export declare type AlertType = 'success' | 'warning' | 'info' | 'error';
export declare type EffectType = 'light' | 'dark';
export declare class NelAlertComponent {
    static ngAcceptInputType_nelShowIcon: BooleanInput;
    static ngAcceptInputType_nelCenter: BooleanInput;
    nelTitle?: string | TemplateRef<void>;
    nelType: AlertType;
    nelEffect: EffectType;
    nelClosable: boolean;
    nelCloseText: string | null;
    nelShowIcon: boolean;
    nelCenter: boolean;
    nelDescription?: string | TemplateRef<void>;
    nelOnClose: EventEmitter<boolean>;
    hide: boolean;
    constructor();
    close(): void;
}
