import { OnDestroy, OnChanges, SimpleChanges, TemplateRef, EventEmitter, ChangeDetectorRef, AfterViewInit } from '@angular/core';
import { Subscription } from 'rxjs';
export declare class NelBacktopComponent implements AfterViewInit, OnDestroy, OnChanges {
    private cdr;
    doc: Document;
    subscribeScoll: Subscription;
    visible: boolean;
    nelTarget: string | HTMLElement;
    nelVisibilityHeight: number;
    nelRight: number;
    nelBottom: number;
    nelTemplate: TemplateRef<void>;
    nelClick: EventEmitter<void>;
    target: HTMLElement | null;
    constructor(doc: any, cdr: ChangeDetectorRef);
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    initTarget(): void;
    getTarget(): HTMLElement | Window;
    getScroll(): number;
    registerScrollEvent(): void;
    handleScroll(): void;
    backTop(): void;
    scrollTop(): void;
    ngOnChanges(changes: SimpleChanges): void;
}
