(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/breadcrumb', ['exports', '@angular/core', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].breadcrumb = {}), global.ng.core, global['ng-element-ui'].core.outlet));
}(this, (function (exports, core, outlet) { 'use strict';

    var NelBreadcrumbComponent = /** @class */ (function () {
        function NelBreadcrumbComponent() {
            this.nelSeparator = '/';
        }
        return NelBreadcrumbComponent;
    }());
    NelBreadcrumbComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-breadcrumb',
                    template: "<ng-content></ng-content>\r\n",
                    host: {
                        class: 'el-breadcrumb'
                    }
                },] }
    ];
    NelBreadcrumbComponent.propDecorators = {
        nelSeparator: [{ type: core.Input }]
    };

    var NelBreadcrumbItemComponent = /** @class */ (function () {
        function NelBreadcrumbItemComponent(nelBreadcrumbComponent) {
            this.nelBreadcrumbComponent = nelBreadcrumbComponent;
        }
        return NelBreadcrumbItemComponent;
    }());
    NelBreadcrumbItemComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-breadcrumb-item',
                    template: "<span class=\"el-breadcrumb__inner\" role=\"link\">\r\n  <ng-content></ng-content>\r\n</span>\r\n<span class=\"el-breadcrumb__separator\">\r\n  <ng-container *stringTemplate=\"nelBreadcrumbComponent.nelSeparator\">{{nelBreadcrumbComponent.nelSeparator}}\r\n  </ng-container>\r\n</span>\r\n",
                    host: {
                        class: 'el-breadcrumb__item'
                    }
                },] }
    ];
    NelBreadcrumbItemComponent.ctorParameters = function () { return [
        { type: NelBreadcrumbComponent }
    ]; };

    var NelBreadcrumbModule = /** @class */ (function () {
        function NelBreadcrumbModule() {
        }
        return NelBreadcrumbModule;
    }());
    NelBreadcrumbModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelBreadcrumbComponent,
                        NelBreadcrumbItemComponent
                    ],
                    exports: [
                        NelBreadcrumbComponent,
                        NelBreadcrumbItemComponent
                    ],
                    imports: [
                        outlet.NelOutletModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelBreadcrumbComponent = NelBreadcrumbComponent;
    exports.NelBreadcrumbItemComponent = NelBreadcrumbItemComponent;
    exports.NelBreadcrumbModule = NelBreadcrumbModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-breadcrumb.umd.js.map
