(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/container', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].container = {}), global.ng.core));
}(this, (function (exports, core) { 'use strict';

    var NelHeaderComponent = /** @class */ (function () {
        function NelHeaderComponent() {
        }
        return NelHeaderComponent;
    }());
    NelHeaderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-header',
                    template: "<ng-content></ng-content>\r\n",
                    host: {
                        '[class.el-header]': 'true'
                    }
                },] }
    ];

    var NelFooterComponent = /** @class */ (function () {
        function NelFooterComponent() {
        }
        return NelFooterComponent;
    }());
    NelFooterComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-footer',
                    template: "<ng-content></ng-content>\r\n",
                    host: {
                        '[class.el-footer]': 'true'
                    }
                },] }
    ];

    var NelContainerComponent = /** @class */ (function () {
        function NelContainerComponent() {
            this.vertical = false;
        }
        NelContainerComponent.prototype.ngAfterContentInit = function () {
            if (this.headerList.length > 0 || this.footerList.length > 0) {
                this.vertical = true;
            }
        };
        return NelContainerComponent;
    }());
    NelContainerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-container',
                    template: "<ng-content></ng-content>\r\n",
                    host: {
                        '[class.el-container]': 'true',
                        '[class.is-vertical]': 'vertical'
                    }
                },] }
    ];
    NelContainerComponent.propDecorators = {
        headerList: [{ type: core.ContentChildren, args: [NelHeaderComponent, { descendants: false },] }],
        footerList: [{ type: core.ContentChildren, args: [NelFooterComponent, { descendants: false },] }]
    };

    var NelAsideComponent = /** @class */ (function () {
        function NelAsideComponent() {
        }
        return NelAsideComponent;
    }());
    NelAsideComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-aside',
                    template: "<ng-content></ng-content>\r\n",
                    host: {
                        '[class.el-aside]': 'true'
                    }
                },] }
    ];

    var NelMainComponent = /** @class */ (function () {
        function NelMainComponent() {
        }
        return NelMainComponent;
    }());
    NelMainComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-main',
                    template: "<ng-content></ng-content>\r\n",
                    host: {
                        '[class.el-main]': 'true'
                    }
                },] }
    ];

    var NelContainerModule = /** @class */ (function () {
        function NelContainerModule() {
        }
        return NelContainerModule;
    }());
    NelContainerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelContainerComponent,
                        NelHeaderComponent,
                        NelAsideComponent,
                        NelMainComponent,
                        NelFooterComponent
                    ],
                    exports: [
                        NelContainerComponent,
                        NelHeaderComponent,
                        NelAsideComponent,
                        NelMainComponent,
                        NelFooterComponent
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelAsideComponent = NelAsideComponent;
    exports.NelContainerComponent = NelContainerComponent;
    exports.NelContainerModule = NelContainerModule;
    exports.NelFooterComponent = NelFooterComponent;
    exports.NelHeaderComponent = NelHeaderComponent;
    exports.NelMainComponent = NelMainComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-container.umd.js.map
