(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/services')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/icon', ['exports', '@angular/core', 'ng-element-ui/core/services'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].icon = {}), global.ng.core, global['ng-element-ui'].core.services));
}(this, (function (exports, core, services) { 'use strict';

    var NelIconDirective = /** @class */ (function () {
        function NelIconDirective(elementRef, renderer, updateHostClassService) {
            this.elementRef = elementRef;
            this.renderer = renderer;
            this.updateHostClassService = updateHostClassService;
            this.el = this.elementRef.nativeElement;
            this.type = '';
        }
        Object.defineProperty(NelIconDirective.prototype, "nelType", {
            set: function (value) {
                this.renderer.addClass(this.el, "el-icon-" + value);
            },
            enumerable: false,
            configurable: true
        });
        NelIconDirective.prototype.ngOnChanges = function (changes) {
            if (changes.type) {
                this.setClassMap();
            }
        };
        NelIconDirective.prototype.setClassMap = function () {
            var _a;
            this.updateHostClassService.updateHostClass(this.el, (_a = {},
                _a["el-icon-" + this.type] = this.type,
                _a));
        };
        return NelIconDirective;
    }());
    NelIconDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[nel-icon]'
                },] }
    ];
    NelIconDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: services.NelUpdateHostClassService }
    ]; };
    NelIconDirective.propDecorators = {
        nelType: [{ type: core.Input }]
    };

    var NelIconModule = /** @class */ (function () {
        function NelIconModule() {
        }
        return NelIconModule;
    }());
    NelIconModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelIconDirective
                    ],
                    exports: [
                        NelIconDirective
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelIconDirective = NelIconDirective;
    exports.NelIconModule = NelIconModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-icon.umd.js.map
