(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/utils'), require('rxjs'), require('rxjs/operators'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('@angular/common'), require('@angular/cdk/drag-drop'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/image', ['exports', '@angular/core', 'ng-element-ui/core/utils', 'rxjs', 'rxjs/operators', '@angular/cdk/portal', '@angular/cdk/overlay', '@angular/common', '@angular/cdk/drag-drop', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].image = {}), global.ng.core, global['ng-element-ui'].core.utils, global.rxjs, global.rxjs.operators, global.ng.cdk.portal, global.ng.cdk.overlay, global.ng.common, global.ng.cdk.dragDrop, global['ng-element-ui'].core.outlet));
}(this, (function (exports, i0, utils, rxjs, operators, portal, i1, common, dragDrop, outlet) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var ImageRef = /** @class */ (function () {
        function ImageRef(overlay, nelUrlList, nelInitialIndex, nelInfinite, nelOnClose, nelOnSwitch) {
            if (nelInfinite === void 0) { nelInfinite = true; }
            this.overlay = overlay;
            this.nelUrlList = nelUrlList;
            this.nelInitialIndex = nelInitialIndex;
            this.nelInfinite = nelInfinite;
            this.nelOnClose = nelOnClose;
            this.nelOnSwitch = nelOnSwitch;
            this.afterClosed$ = new rxjs.Subject();
        }
        ImageRef.prototype.colse = function (data) {
            this._close('close', data);
        };
        ImageRef.prototype._close = function (type, data) {
            this.overlay.dispose();
            this.afterClosed$.next({
                type: type,
                data: data
            });
            this.afterClosed$.complete();
        };
        return ImageRef;
    }());

    var NelImageViewerComponent = /** @class */ (function () {
        function NelImageViewerComponent(imageRef) {
            this.imageRef = imageRef;
            this.nelInfinite = true;
            this.deg = 0;
            this.scale = 1;
            this.isOriginal = false;
        }
        NelImageViewerComponent.prototype.ngOnInit = function () {
            this.nelUrlList = this.imageRef.nelUrlList;
            this.nelInitialIndex =
                !this.imageRef.nelInitialIndex || this.imageRef.nelInitialIndex > this.imageRef.nelUrlList.length ? 0 : this.imageRef.nelInitialIndex;
            this.nelInfinite = this.imageRef.nelInfinite;
        };
        NelImageViewerComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.imgList.forEach(function (item, index) {
                item.nativeElement.style.transform = 'scale(1) rotate(0deg)';
                item.nativeElement.style.marginLeft = '0px';
                item.nativeElement.style.marginTop = '0px';
                item.nativeElement.style.maxHeight = '100%';
                item.nativeElement.style.maxWidth = '100%';
                if (index !== _this.nelInitialIndex) {
                    item.nativeElement.style.display = 'none';
                }
            });
        };
        NelImageViewerComponent.prototype.close = function () {
            this.imageRef.colse(this.nelInitialIndex);
            if (this.imageRef.nelOnClose) {
                this.imageRef.nelOnClose();
            }
        };
        NelImageViewerComponent.prototype.prev = function () {
            if (this.nelInitialIndex - 1 < 0) {
                if (this.nelInfinite) {
                    this.nelInitialIndex = this.nelUrlList.length - 1;
                }
                else {
                    this.nelInitialIndex = 0;
                }
            }
            else {
                this.nelInitialIndex -= 1;
            }
            if (this.imageRef.nelOnSwitch) {
                this.imageRef.nelOnSwitch(this.nelInitialIndex);
            }
            this.deg = 0;
            this.scale = 1;
            this.setupTransform();
        };
        NelImageViewerComponent.prototype.next = function () {
            if (this.nelInitialIndex + 1 < this.nelUrlList.length) {
                this.nelInitialIndex += 1;
            }
            else {
                if (this.nelInfinite) {
                    this.nelInitialIndex = 0;
                }
                else {
                    this.nelInitialIndex = this.nelUrlList.length - 1;
                }
            }
            if (this.imageRef.nelOnSwitch) {
                this.imageRef.nelOnSwitch(this.nelInitialIndex);
            }
            this.deg = 0;
            this.scale = 1;
            this.setupTransform();
        };
        NelImageViewerComponent.prototype.rotateImage = function (val) {
            this.deg = this.deg + val;
            this.setupTransform();
        };
        NelImageViewerComponent.prototype.scaleImage = function (val) {
            this.scale = this.scale + val;
            if (this.scale < 0.2) {
                this.scale = 0.2;
            }
            this.setupTransform();
        };
        NelImageViewerComponent.prototype.setupTransform = function (transition) {
            if (transition === void 0) { transition = true; }
            var imgEle = this.imgList.get(this.nelInitialIndex);
            if (imgEle) {
                if (transition) {
                    imgEle.nativeElement.style.transition = 'transform 0.3s ease 0s';
                }
                else {
                    imgEle.nativeElement.style.transition = '';
                }
                imgEle.nativeElement.style.transform = "scale(" + this.scale + ") rotate(" + this.deg * 90 + "deg)";
            }
        };
        NelImageViewerComponent.prototype.changeType = function () {
            this.isOriginal = !this.isOriginal;
            this.deg = 0;
            this.scale = 1;
            this.setupTransform(false);
        };
        NelImageViewerComponent.prototype.dragStarted = function () {
            var imgEle = this.imgList.get(this.nelInitialIndex);
            if (imgEle) {
                imgEle.nativeElement.style.transition = '';
            }
        };
        NelImageViewerComponent.prototype.wheelScroll = function ($event) {
            $event.stopPropagation();
            var wheelDirection = $event.wheelDelta || -$event.deltaY;
            if (wheelDirection > 0) {
                // 往上滚动
                this.scaleImage(0.015);
            }
            else {
                // 往下滚动
                this.scaleImage(-0.015);
            }
        };
        return NelImageViewerComponent;
    }());
    NelImageViewerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'nel-image-viewer',
                    template: "<div tabindex=\"-1\" class=\"el-image-viewer__wrapper\" style=\"z-index: 2000;\">\r\n  <div class=\"el-image-viewer__mask\"></div>\r\n  <span class=\"el-image-viewer__btn el-image-viewer__close\" (click)=\"close()\">\r\n    <i class=\"el-icon-close\"></i>\r\n  </span>\r\n  <span class=\"el-image-viewer__btn el-image-viewer__prev\" (click)=\"prev()\">\r\n    <i class=\"el-icon-arrow-left\"></i>\r\n  </span>\r\n  <span class=\"el-image-viewer__btn el-image-viewer__next\" (click)=\"next()\">\r\n    <i class=\"el-icon-arrow-right\"></i>\r\n  </span>\r\n  <div class=\"el-image-viewer__btn el-image-viewer__actions\">\r\n    <div class=\"el-image-viewer__actions__inner\">\r\n      <i class=\"el-icon-zoom-out\" (click)=\"scaleImage(-0.2)\"></i>\r\n      <i class=\"el-icon-zoom-in\" (click)=\"scaleImage(0.2)\"></i>\r\n      <i class=\"el-image-viewer__actions__divider\"></i>\r\n      <i *ngIf=\"!isOriginal\" class=\"el-icon-full-screen\" (click)=\"changeType()\"></i>\r\n      <i *ngIf=\"isOriginal\" class=\"el-icon-c-scale-to-original\" (click)=\"changeType()\"></i>\r\n      <i class=\"el-image-viewer__actions__divider\"></i>\r\n      <i class=\"el-icon-refresh-left\" (click)=\"rotateImage(-1)\"></i>\r\n      <i class=\"el-icon-refresh-right\" (click)=\"rotateImage(1)\"></i>\r\n    </div>\r\n  </div>\r\n  <div cdkDrag (cdkDragStarted)=\"dragStarted()\" class=\"el-image-viewer__canvas\">\r\n    <img cdkDragHandle #imgEle *ngFor=\"let url of nelUrlList; let index=index\" [src]=\"url\"\r\n      [style.display]=\"index != nelInitialIndex ? 'none' : ''\"\r\n      [ngStyle]=\"{'max-height': isOriginal ? '' : '100%', 'max-width': isOriginal ? '' : '100%'}\"\r\n      class=\"el-image-viewer__img\">\r\n    <div>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush
                },] }
    ];
    NelImageViewerComponent.ctorParameters = function () { return [
        { type: ImageRef }
    ]; };
    NelImageViewerComponent.propDecorators = {
        imgList: [{ type: i0.ViewChildren, args: ['imgEle',] }],
        wheelScroll: [{ type: i0.HostListener, args: ['wheel', ['$event'],] }]
    };

    var NelImageService = /** @class */ (function () {
        function NelImageService(overlay, injector) {
            this.overlay = overlay;
            this.injector = injector;
        }
        NelImageService.prototype.preview = function (config) {
            var overlayRef = this.overlay.create();
            var imageRef = new ImageRef(overlayRef, config.nelUrlList, config.nelInitialIndex, config.nelInfinite, config.nelOnClose, config.nelOnSwitch);
            var injector = this.createInjector(imageRef, this.injector);
            overlayRef.attach(new portal.ComponentPortal(NelImageViewerComponent, null, injector));
            return imageRef;
        };
        NelImageService.prototype.createInjector = function (ref, inj) {
            var injectorTokens = new WeakMap([[ImageRef, ref]]);
            return new portal.PortalInjector(inj, injectorTokens);
        };
        return NelImageService;
    }());
    NelImageService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NelImageService_Factory() { return new NelImageService(i0.ɵɵinject(i1.Overlay), i0.ɵɵinject(i0.INJECTOR)); }, token: NelImageService, providedIn: "root" });
    NelImageService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NelImageService.ctorParameters = function () { return [
        { type: i1.Overlay },
        { type: i0.Injector }
    ]; };

    var NelImageComponent = /** @class */ (function () {
        function NelImageComponent(elementRef, cdr, image) {
            this.elementRef = elementRef;
            this.cdr = cdr;
            this.image = image;
            this.loading = true;
            this.hasLoadError = false;
            this.nelLazy = false;
            this.nelOnLoad = new i0.EventEmitter();
            this.nelOnError = new i0.EventEmitter();
        }
        NelImageComponent.prototype.ngOnDestroy = function () {
            if (this.subscribeLazy) {
                this.subscribeLazy.unsubscribe();
            }
        };
        NelImageComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (this.nelSrc) {
                if (this.nelLazy) {
                    this.container = utils.getScrollContainer(this.elementRef.nativeElement, true);
                    var clientHeight = this.container.clientHeight;
                    var offsetTop = this.container.offsetTop;
                    var elOffsetTop = this.elementRef.nativeElement.offsetTop;
                    if (elOffsetTop - offsetTop <= clientHeight) {
                        this.loadImage();
                    }
                    else {
                        this.lazyImage();
                    }
                }
                else {
                    this.loadImage();
                }
            }
            else {
                setTimeout(function () {
                    _this.loading = false;
                    _this.hasLoadError = true;
                    _this.cdr.markForCheck();
                }, 0);
            }
        };
        NelImageComponent.prototype.loadImage = function () {
            var _this = this;
            this.loading = true;
            setTimeout(function () {
                var img = new Image();
                img.src = _this.nelSrc;
                img.onload = function (e) {
                    _this.handlerLoad(e);
                };
                img.onerror = function (e) {
                    _this.handlerError(e);
                };
            }, 0);
        };
        NelImageComponent.prototype.lazyImage = function () {
            var _this = this;
            setTimeout(function () {
                _this.loading = true;
                _this.subscribeLazy = rxjs.fromEvent(_this.container, 'scroll')
                    .pipe(operators.debounceTime(200))
                    .subscribe(function () {
                    _this.handleLazy();
                });
            }, 0);
        };
        NelImageComponent.prototype.handlerLoad = function (e) {
            this.loading = false;
            this.src = this.nelSrc;
            this.nelOnLoad.emit(e);
            this.cdr.markForCheck();
        };
        NelImageComponent.prototype.handlerError = function (e) {
            this.loading = false;
            this.hasLoadError = true;
            this.nelOnError.emit(e);
            this.cdr.markForCheck();
        };
        NelImageComponent.prototype.handleLazy = function () {
            var clientHeight = this.container.clientHeight;
            var offsetTop = this.container.offsetTop;
            var scrollTop = this.container.scrollTop;
            var elOffsetTop = this.elementRef.nativeElement.offsetTop;
            if (elOffsetTop - offsetTop <= clientHeight + scrollTop) {
                this.loadImage();
                this.subscribeLazy.unsubscribe();
            }
        };
        NelImageComponent.prototype.preview = function () {
            if (this.nelPreviewSrcList && this.nelPreviewSrcList.length > 0) {
                this.image.preview({
                    nelUrlList: this.nelPreviewSrcList,
                    nelInitialIndex: 0
                });
            }
        };
        return NelImageComponent;
    }());
    NelImageComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'nel-image',
                    template: "<img *ngIf=\"!loading && !hasLoadError\" (click)=\"preview()\" class=\"el-image__inner\" [src]=\"src\"\r\n  [style.object-fit]=\"nelFit\" [alt]=\"nelAlt\">\r\n<div *ngIf=\"loading\" class=\"el-image__placeholder\">\r\n  <ng-container *ngIf=\"nelPlaceholder\">\r\n    <ng-container *stringTemplate=\"nelPlaceholder\">{{nelPlaceholder}}</ng-container>\r\n  </ng-container>\r\n</div>\r\n<div *ngIf=\"hasLoadError\" class=\"el-image__error\">\r\n  <ng-container *ngIf=\"nelError; else errorTpl\">\r\n    <ng-container *stringTemplate=\"nelError\">{{nelError}}</ng-container>\r\n  </ng-container>\r\n  <ng-template #errorTpl>\u52A0\u8F7D\u5931\u8D25</ng-template>\r\n</div>\r\n",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'el-image'
                    }
                },] }
    ];
    NelImageComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.ChangeDetectorRef },
        { type: NelImageService }
    ]; };
    NelImageComponent.propDecorators = {
        nelSrc: [{ type: i0.Input }],
        nelFit: [{ type: i0.Input }],
        nelAlt: [{ type: i0.Input }],
        nelPlaceholder: [{ type: i0.Input }],
        nelError: [{ type: i0.Input }],
        nelLazy: [{ type: i0.Input }],
        nelPreviewSrcList: [{ type: i0.Input }],
        nelOnLoad: [{ type: i0.Output }],
        nelOnError: [{ type: i0.Output }]
    };
    __decorate([
        utils.InputBoolean()
    ], NelImageComponent.prototype, "nelLazy", void 0);

    var NelImageModule = /** @class */ (function () {
        function NelImageModule() {
        }
        return NelImageModule;
    }());
    NelImageModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        NelImageComponent,
                        NelImageViewerComponent
                    ],
                    exports: [
                        NelImageComponent,
                        NelImageViewerComponent
                    ],
                    imports: [
                        common.CommonModule,
                        i1.OverlayModule,
                        dragDrop.DragDropModule,
                        outlet.NelOutletModule
                    ],
                    providers: [
                        NelImageService
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelImageComponent = NelImageComponent;
    exports.NelImageModule = NelImageModule;
    exports.NelImageService = NelImageService;
    exports.NelImageViewerComponent = NelImageViewerComponent;
    exports.ɵa = ImageRef;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-image.umd.js.map
