(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng-element-ui/core/outlet'), require('ng-element-ui/icon')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/page-header', ['exports', '@angular/core', '@angular/common', 'ng-element-ui/core/outlet', 'ng-element-ui/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui']['page-header'] = {}), global.ng.core, global.ng.common, global['ng-element-ui'].core.outlet, global['ng-element-ui'].icon));
}(this, (function (exports, core, common, outlet, icon) { 'use strict';

    var NelPageHeaderComponent = /** @class */ (function () {
        function NelPageHeaderComponent() {
            this.nelIcon = 'back';
            this.nelTitle = '返回';
            this.nelOnBack = new core.EventEmitter();
        }
        NelPageHeaderComponent.prototype.goBack = function () {
            this.nelOnBack.emit();
        };
        return NelPageHeaderComponent;
    }());
    NelPageHeaderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-page-header',
                    template: "<div class=\"el-page-header\">\r\n  <div class=\"el-page-header__left\" (click)=\"goBack()\">\r\n    <div class=\"el-page-header__icon\">\r\n      <i nel-icon [nelType]=\"nelIcon\"></i>\r\n    </div>\r\n    <div class=\"el-page-header__title\">\r\n      <ng-container *stringTemplate=\"nelTitle\">{{nelTitle}}</ng-container>\r\n    </div>\r\n  </div>\r\n  <div class=\"el-page-header__content\" *ngIf=\"nelContent\">\r\n    <ng-container *stringTemplate=\"nelContent\">{{nelContent}}</ng-container>\r\n  </div>\r\n</div>\r\n"
                },] }
    ];
    NelPageHeaderComponent.propDecorators = {
        nelIcon: [{ type: core.Input }],
        nelTitle: [{ type: core.Input }],
        nelContent: [{ type: core.Input }],
        nelOnBack: [{ type: core.Output }]
    };

    var NelPageHeaderModule = /** @class */ (function () {
        function NelPageHeaderModule() {
        }
        return NelPageHeaderModule;
    }());
    NelPageHeaderModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelPageHeaderComponent
                    ],
                    exports: [
                        NelPageHeaderComponent
                    ],
                    imports: [
                        common.CommonModule,
                        outlet.NelOutletModule,
                        icon.NelIconModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelPageHeaderComponent = NelPageHeaderComponent;
    exports.NelPageHeaderModule = NelPageHeaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-page-header.umd.js.map
