(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/utils'), require('@angular/common'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/tabs', ['exports', '@angular/core', 'ng-element-ui/core/utils', '@angular/common', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].tabs = {}), global.ng.core, global['ng-element-ui'].core.utils, global.ng.common, global['ng-element-ui'].core.outlet));
}(this, (function (exports, core, utils, common, outlet) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var NelTabPaneComponent = /** @class */ (function () {
        function NelTabPaneComponent() {
            this.active = false;
        }
        return NelTabPaneComponent;
    }());
    NelTabPaneComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-tab-pane',
                    template: "<ng-template>\r\n  <ng-content></ng-content>\r\n</ng-template>\r\n<div class=\"el-tab-pane\" [style.display]=\"active ? '' : 'none'\">\r\n  <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n</div>\r\n"
                },] }
    ];
    NelTabPaneComponent.propDecorators = {
        nelLabel: [{ type: core.Input }],
        content: [{ type: core.ViewChild, args: [core.TemplateRef, { static: true },] }]
    };

    var NelTabsComponent = /** @class */ (function () {
        function NelTabsComponent(cdr) {
            this.cdr = cdr;
            this._tabLabelCount = 0;
            this._tabItems = [];
            this.activeBar = {
                width: '',
                height: '',
                transform: ''
            };
            this.scrollable = false;
            this.scrollTransform = '';
            this.nelSelectedIndex = 0;
            this.nelTabPosition = 'top';
            this.nelEditable = false;
            this.nelSelectedIndexChange = new core.EventEmitter();
            this.nelOnEdit = new core.EventEmitter();
        }
        NelTabsComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._tabLabelCount = this.items.length;
            setTimeout(function () {
                _this.changeTabPane();
            }, 0);
        };
        NelTabsComponent.prototype.ngAfterContentChecked = function () {
            if (this._tabLabelCount !== this.items.length) {
                this.ngAfterViewInit();
                this.ngAfterContentInit();
            }
        };
        NelTabsComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (!this.nelType) {
                this._tabItems = [];
                this.tabItems.forEach(function (item) {
                    var _item = {
                        width: item.nativeElement.offsetWidth,
                        height: item.nativeElement.offsetHeight,
                    };
                    _this._tabItems.push(_item);
                });
            }
            this.changeScroll();
            this.changeTab(true);
        };
        NelTabsComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            var nelTabPosition = changes.nelTabPosition;
            if ((nelTabPosition && !nelTabPosition.firstChange)) {
                setTimeout(function () {
                    _this.ngAfterViewInit();
                }, 0);
            }
        };
        NelTabsComponent.prototype.changeTabPane = function () {
            this.items.forEach(function (item) {
                item.active = false;
            });
            var activeItem = this.items.get(this.nelSelectedIndex);
            if (activeItem) {
                activeItem.active = true;
            }
        };
        NelTabsComponent.prototype.selecteTab = function (val) {
            this.nelSelectedIndex = val;
            this.nelSelectedIndexChange.emit(val);
            this.changeTab(false);
            this.changeTabPane();
        };
        NelTabsComponent.prototype.changeTab = function (init) {
            var _this = this;
            if (!this.nelType) {
                var key_1 = 'width';
                if (this.nelTabPosition === 'right' || this.nelTabPosition === 'left') {
                    key_1 = 'height';
                }
                var width_1 = 0;
                var height_1 = 0;
                var transform_1 = 0;
                if (key_1 === 'width') {
                    this._tabItems.forEach(function (item, index) {
                        if (index < _this.nelSelectedIndex) {
                            transform_1 += item[key_1];
                        }
                        else if (index === _this.nelSelectedIndex) {
                            width_1 = item[key_1];
                        }
                    });
                    if (this.nelSelectedIndex === this.tabItems.length - 1) {
                        transform_1 += 20;
                        width_1 -= 20;
                    }
                    else if (this.nelSelectedIndex > 0) {
                        transform_1 += 20;
                        width_1 -= 40;
                    }
                    else {
                        width_1 -= 20;
                    }
                }
                else {
                    this._tabItems.forEach(function (item, index) {
                        if (index < _this.nelSelectedIndex) {
                            transform_1 += item[key_1];
                        }
                        else if (index === _this.nelSelectedIndex) {
                            height_1 = item[key_1];
                        }
                    });
                }
                if (init) {
                    setTimeout(function () {
                        _this.activeBar = {
                            width: key_1 === 'width' ? width_1 + 'px' : '',
                            height: key_1 === 'height' ? height_1 + 'px' : '',
                            transform: key_1 === 'width' ? "translateX(" + transform_1 + "px)" : "translateY(" + transform_1 + "px)"
                        };
                    }, 0);
                }
                else {
                    this.activeBar = {
                        width: key_1 === 'width' ? width_1 + 'px' : '',
                        height: key_1 === 'height' ? height_1 + 'px' : '',
                        transform: key_1 === 'width' ? "translateX(" + transform_1 + "px)" : "translateY(" + transform_1 + "px)"
                    };
                }
            }
        };
        NelTabsComponent.prototype.changeScroll = function () {
            var _this = this;
            // 判断是否显示滚动条
            setTimeout(function () {
                if (_this.navScroll.nativeElement.offsetWidth < _this.navScrollPosition.nativeElement.offsetWidth) {
                    _this.scrollable = true;
                    _this.scrollTransform = "translateX(" + (_this.navScroll.nativeElement.offsetWidth - _this.navScrollPosition.nativeElement.offsetWidth) + "px)";
                    _this.cdr.markForCheck();
                }
                else {
                    _this.scrollable = false;
                    _this.scrollTransform = 'translateX(0px)';
                    _this.cdr.markForCheck();
                }
            }, 0);
        };
        NelTabsComponent.prototype.edit = function () {
            this.nelOnEdit.emit({ index: -1, action: 'add' });
        };
        NelTabsComponent.prototype.remove = function (event, _index) {
            event.stopPropagation();
            this.nelOnEdit.emit({ index: _index, action: 'remove' });
        };
        return NelTabsComponent;
    }());
    NelTabsComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-tabs',
                    template: "<div class=\"el-tabs el-tabs--{{nelTabPosition}}\" [class.el-tabs--card]=\"nelType == 'card'\"\r\n  [class.el-tabs--border-card]=\"nelType == 'border-card'\">\r\n  <ng-container *ngIf=\"nelTabPosition != 'bottom'\">\r\n    <ng-container *ngTemplateOutlet=\"tabsTpl\"></ng-container>\r\n  </ng-container>\r\n  <div class=\"el-tabs__content\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n  <ng-container *ngIf=\"nelTabPosition == 'bottom'\">\r\n    <ng-container *ngTemplateOutlet=\"tabsTpl\"></ng-container>\r\n  </ng-container>\r\n</div>\r\n<ng-template #tabsTpl>\r\n  <div class=\"el-tabs__header is-{{nelTabPosition}}\">\r\n    <span *ngIf=\"nelType == 'card' && this.nelEditable\" (click)=\"edit()\" class=\"el-tabs__new-tab\" tabindex=\"0\">\r\n      <i class=\"el-icon-plus\"></i>\r\n    </span>\r\n    <div class=\"el-tabs__nav-wrap is-{{nelTabPosition}}\" [class.is-scrollable]=\"scrollable\">\r\n      <!-- scrollable -->\r\n      <ng-container *ngIf=\"scrollable\">\r\n        <span class=\"el-tabs__nav-prev\"><i class=\"el-icon-arrow-left\"></i></span>\r\n        <span class=\"el-tabs__nav-next is-disabled\"><i class=\"el-icon-arrow-right\"></i></span>\r\n      </ng-container>\r\n      <div #navScroll class=\"el-tabs__nav-scroll\">\r\n        <div #navScrollPosition class=\"el-tabs__nav is-{{nelTabPosition}}\" [style.transform]=\"scrollTransform\">\r\n          <div *ngIf=\"!nelType\" class=\"el-tabs__active-bar is-{{nelTabPosition}}\" [style.width]=\"activeBar.width\"\r\n            [style.height]=\"activeBar.height\" [style.transform]=\"activeBar.transform\"></div>\r\n          <ng-container *ngFor=\"let tabPane of items; let index=index\">\r\n            <div #tabItem (click)=\"selecteTab(index)\" class=\"el-tabs__item is-{{nelTabPosition}}\"\r\n              [class.is-active]=\"index == nelSelectedIndex\" [class.is-closable]=\"nelType == 'card' && this.nelEditable\">\r\n              <ng-container *ngIf=\"tabPane.nelLabel\">\r\n                <ng-container *stringTemplate=\"tabPane.nelLabel\">{{tabPane.nelLabel}}</ng-container>\r\n              </ng-container>\r\n              <span *ngIf=\"nelType == 'card' && this.nelEditable\" (click)=\"remove($event, index)\"\r\n                class=\"el-icon-close\"></span>\r\n            </div>\r\n          </ng-container>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    NelTabsComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    NelTabsComponent.propDecorators = {
        nelSelectedIndex: [{ type: core.Input }],
        nelType: [{ type: core.Input }],
        nelTabPosition: [{ type: core.Input }],
        nelEditable: [{ type: core.Input }],
        items: [{ type: core.ContentChildren, args: [NelTabPaneComponent, { descendants: false },] }],
        tabItems: [{ type: core.ViewChildren, args: ['tabItem',] }],
        navScroll: [{ type: core.ViewChild, args: ['navScroll', { static: false },] }],
        navScrollPosition: [{ type: core.ViewChild, args: ['navScrollPosition', { static: false },] }],
        nelSelectedIndexChange: [{ type: core.Output }],
        nelOnEdit: [{ type: core.Output }]
    };
    __decorate([
        utils.InputBoolean()
    ], NelTabsComponent.prototype, "nelEditable", void 0);

    var NelTabsModule = /** @class */ (function () {
        function NelTabsModule() {
        }
        return NelTabsModule;
    }());
    NelTabsModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelTabsComponent,
                        NelTabPaneComponent
                    ],
                    exports: [
                        NelTabsComponent,
                        NelTabPaneComponent
                    ],
                    imports: [
                        common.CommonModule,
                        outlet.NelOutletModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelTabPaneComponent = NelTabPaneComponent;
    exports.NelTabsComponent = NelTabsComponent;
    exports.NelTabsModule = NelTabsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-tabs.umd.js.map
