import { QueryList, ElementRef, AfterViewInit, OnDestroy } from '@angular/core';
import { NelCarouselItemComponent } from './carousel-item.component';
export declare class NelCarouselComponent implements AfterViewInit, OnDestroy {
    hover: boolean;
    width: number;
    height: number;
    active: number;
    CARD_SCALE: number;
    nelHeight?: string;
    nelTrigger?: 'click';
    nelIndicatorPosition?: 'outside';
    nelArrow: 'always' | 'hover' | 'never';
    nelType?: 'card';
    nelDirection: 'horizontal' | 'vertical';
    items: QueryList<NelCarouselItemComponent>;
    containerEle: ElementRef;
    itemContainerEle: ElementRef;
    indicatorList: QueryList<ElementRef>;
    constructor();
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    mouseEnter(): void;
    mouseLeave(): void;
    prev(): void;
    next(): void;
    indicatorSelect(index: number): void;
    selectItem(index: number): void;
    changeActive(active: number, indicator: boolean): void;
}
