import { ChangeDetectorRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelCheckboxService } from './checkbox.service';
export declare class NelCheckboxComponent implements ControlValueAccessor {
    private checkbox;
    private cdr;
    static ngAcceptInputType_nelDisabled: BooleanInput;
    isChecked: boolean;
    nelValue: any;
    nelDisabled: boolean;
    nelIndeterminate: boolean;
    data: any;
    change: (val: any) => void;
    constructor(checkbox: NelCheckboxService, cdr: ChangeDetectorRef);
    onHostClick(event: MouseEvent): void;
    changeView(): void;
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
