import { OverlayRef } from '@angular/cdk/overlay';
import { Subject } from 'rxjs';
export interface OverlayCloseEvent<R> {
    type: 'backdropClick' | 'close';
    data: R | null;
}
export declare class DialogRef<R = any> {
    overlay: OverlayRef;
    nelTitle?: string | undefined;
    nelContent?: string | undefined;
    nelOnCancel?: Function | undefined;
    nelOnOk?: Function | undefined;
    afterClosed$: Subject<OverlayCloseEvent<R>>;
    constructor(overlay: OverlayRef, nelTitle?: string | undefined, nelContent?: string | undefined, nelOnCancel?: Function | undefined, nelOnOk?: Function | undefined);
    close(data: R | null): void;
    private _close;
}
