import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { ElementRef, ViewContainerRef, EventEmitter, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
export declare class NelDrawerComponent {
    protected hostView: ViewContainerRef;
    private elementRef;
    width: string;
    height: string;
    nelTitle?: string | TemplateRef<void>;
    nelDirection?: 'rtl' | 'ltr' | 'ttb' | 'btt' | string;
    nelWithHeader: boolean;
    nelShowClose: boolean;
    nelBeforeClose?: () => boolean | Observable<boolean>;
    set nelSize(val: number | string);
    set nelVisible(val: boolean);
    nelVisibleChange: EventEmitter<boolean>;
    isOpen: boolean;
    trigger: CdkOverlayOrigin;
    constructor(hostView: ViewContainerRef, elementRef: ElementRef);
    show(): void;
    handleClose(): void;
    close(): void;
    clickDrawer($event: Event): void;
}
