import { TemplateRef, OnInit } from '@angular/core';
import { OverlayRef } from '@angular/cdk/overlay';
import { AnimationEvent } from '@angular/animations';
import { MessageBoxRef } from './message-box-ref';
export declare class NelMessageBoxComponent implements OnInit {
    private messageBoxRef;
    boxType: string;
    type?: string;
    title: string | TemplateRef<void>;
    content: string | TemplateRef<void>;
    cancelButtonText: string;
    confirmButtonText: string;
    cancel?: Function;
    confirm?: Function;
    beforeConfirm?: Function;
    center: boolean;
    state: string;
    overlay: OverlayRef;
    leaveType: string;
    constructor(messageBoxRef: MessageBoxRef);
    ngOnInit(): void;
    handleCancel(type: string): void;
    handleConfirm(): void;
    onAnimationDone(event: AnimationEvent): void;
}
