import { OnInit, OnDestroy, ElementRef, AfterViewInit, TemplateRef } from '@angular/core';
import { OverlayRef } from '@angular/cdk/overlay';
import { AnimationEvent } from '@angular/animations';
import { MessageRef } from './message-ref';
export declare class NelMessageComponent implements OnInit, AfterViewInit, OnDestroy {
    private messageRef;
    type: string;
    id: number;
    top: number;
    content: string | TemplateRef<void>;
    showClose: boolean;
    duration: number;
    center: boolean;
    onClose?: Function;
    timer: any;
    state: string;
    overlay: OverlayRef;
    messageEle: ElementRef;
    constructor(messageRef: MessageRef);
    ngOnDestroy(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    initTimer(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    mouseenter(): void;
    mouseleave(): void;
    close(): void;
}
