import { OverlayRef } from '@angular/cdk/overlay';
import { TemplateRef } from '@angular/core';
import { Subject } from 'rxjs';
export declare type PositionType = 'topRight' | 'bottomRight' | 'topLeft' | 'bottomLeft';
export declare class NelNotificationRef<R = any> {
    type: string;
    id: number;
    leave: Subject<{
        id: number;
        position: PositionType;
    }>;
    overlay: OverlayRef;
    title: string | TemplateRef<void>;
    content: string | TemplateRef<void>;
    options: any;
    height: number;
    position: PositionType;
    top: number;
    bottom: number;
    componentInstance: R | null;
    constructor(type: string, id: number, leave: Subject<{
        id: number;
        position: PositionType;
    }>, overlay: OverlayRef, title: string | TemplateRef<void>, content: string | TemplateRef<void>, options: any);
    close(): void;
}
