import { EventEmitter, TemplateRef } from '@angular/core';
import { CdkOverlayOrigin, ConnectionPositionPair } from '@angular/cdk/overlay';
import { TriggerType } from './popover.directive';
export declare class NelPopoverComponent {
    title?: string;
    content?: string | TemplateRef<void>;
    width?: number;
    trigger: TriggerType;
    origin: CdkOverlayOrigin;
    visibleChange: EventEmitter<boolean>;
    isOpen: boolean;
    positionStrategy: ConnectionPositionPair[];
    arrowLeft: string;
    arrowRight: string;
    arrowTop: string;
    arrowBottom: string;
    transform: string;
    onClickOutside(event: MouseEvent): void;
    close(): void;
}
