import { ChangeDetectorRef, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { NelRadioService } from './radio.service';
export declare class NelRadioButtonComponent implements ControlValueAccessor {
    private radio;
    private cdr;
    isChecked: boolean;
    isDisabled: boolean;
    inputDisabled: string;
    size: 'medium' | 'small' | 'mini' | undefined;
    nelValue: any;
    set nelDisabled(val: boolean);
    inputEle: ElementRef;
    data: any;
    change: (value: any) => void;
    constructor(radio: NelRadioService, cdr: ChangeDetectorRef);
    onHostClick(event: MouseEvent): void;
    changeView(): void;
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
