import { ChangeDetectorRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelRadioService } from './radio.service';
export declare type SizeType = 'medium' | 'small' | 'mini';
export declare class NelRadioComponent implements ControlValueAccessor {
    private radio;
    private cdr;
    static ngAcceptInputType_nelBorder: BooleanInput;
    static ngAcceptInputType_nelDisabled: BooleanInput;
    isChecked: boolean;
    nelValue: any;
    nelDisabled: boolean;
    nelBorder: boolean;
    nelSize: SizeType | undefined;
    data: any;
    change: (value: any) => void;
    constructor(radio: NelRadioService, cdr: ChangeDetectorRef);
    onHostClick(event: MouseEvent): void;
    changeView(): void;
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
